<?php
			session_start();

			require_once("./model/gestion_model.php");
			require_once("./model/gestion_model2.php");
			require_once("./model/fpdf/fpdf.php");

			date_default_timezone_set("America/Lima");

			$ges = new gestion_model();
			$ges2 = new gestion_model2();

			$id = $_GET['tecnico'];

			$productos = $ges->get_productos_tecnico_todos($id);
			$series = $ges->get_series($id);

			$codigo_tecnico = $ges->get_codigo_tecnico2($id);

			$tecnico = $ges2->get_trabajador($codigo_tecnico['codigo_usuario']);

			$fecha = date("Y-m-d");

			// SESIÓN INICIADA

			if(isset($_SESSION['id_usuario_almacen']) && isset($_POST['DEVOLVER']) ){

				$cod = date("mds").rand(0,9).rand(0,9).$id;

				

				$solicitud = $ges->get_usuario_unico($id);
				$trabajadores = $ges2->get_trabajadores();
				$found_key="";
                $found_key = array_search($solicitud['codigo_usuario'], array_column($trabajadores, 'DOCIDEN'));
				$trabajador_responsable = $trabajadores[$found_key]['NOMBRES'];
				$found_key2 = array_search($_SESSION['codigo_usuario'], array_column($trabajadores, 'DOCIDEN'));
				$almacenero = $trabajadores[$found_key2]['NOMBRES'];
				$requerimiento = $ges->get_ultimo_requerimiento_almacen();
				$id_plantilla = $requerimiento['id_requerimiento_almacen'] + 1;
				$plantilla = $ges->set_requerimiento2($_SESSION['id_asignacion'], $id, 0);

				$pathname = './pdf/devolucion_'.$id_plantilla.'.pdf';

				Class PDF extends FPDF{
					function Header(){
						
						$this->SetY(10);
						$imagePath = './view/img/IMGBIO.png';
						$imageWidth = 30;
						$pdfWidth = $this->GetPageWidth();
						$centerX = ($pdfWidth - $imageWidth) / 2;

						$this->Image($imagePath, $centerX, 10, $imageWidth, 20);
						$this->SetFont('Arial', 'B', 30);
						$this->Ln(20);
						
						$this->SetFont('Arial','B',12);
						
						$this->Cell(190,11,utf8_decode('ACTA DE DEVOLUCIÓN DE EQUIPOS, MATERIALES Y/O HERRAMIENTAS'),0,0,'C');
						
						$this->Ln(15);

					}
					
					function Footer(){

						$this->SetY(-30);

						$this->Ln(10);
						$this->SetFont('Arial', '', 11);
						$this->Cell(20, 10, '', 0, 0, 'C');
						$this->Cell(65, 10, 'RESPONSABLE ALMACEN', 'T', 0, 'C');
						$this->Cell(20, 10, '', 0, 0, 'C');
						$this->Cell(65, 10, 'TRABAJADOR', 'T', 0, 'C');
						$this->Cell(20, 10, '', 0, 0, 'C');

						$this->Ln();

						$this->SetFont('Arial','I',8);
						
						$this->Cell(0,10,'Pagina '.$this->PageNo().'/{nb}',0,0,'C');

					}
				}

				$pdf = new PDF();
				$pdf->AddPage();
				$pdf->AliasNbPages();
				$pdf->SetFont('Arial','',10);

				$pdf->SetFillColor(255,255,255);

				$pdf->Ln();
                $pdf->MultiCell(190,11,utf8_decode('Con la firma del presente documento, el Sr. '.$almacenero.' identificad(a) con DNI/Carnet de extranjería '.$_SESSION['codigo_usuario'].' en representación de Business Intelligence Outsourcing Bio SAC y el Sr.'.$trabajador_responsable.' identificad(a) con DNI/Carnet de extranjería '.$solicitud['codigo_usuario'].', confirma que los siguientes materiales han sido entregados a la empresa:'),0,'FJ',1);

				$pdf->Ln(11);
				$pdf->SetFont('Arial','B',8);
				$pdf->Cell(78,8,utf8_decode('DESCRIPCIÓN'),1);
				$pdf->Cell(17,8,'CANTIDAD',1);
				$pdf->Cell(15,8,'UND',1);
				$pdf->Cell(30,8,'SERIE',1);
				$pdf->Cell(20,8,'ESTADO',1);
				$pdf->Cell(30,8,utf8_decode('OBSERVACIÓN'),1);
				$w =array(78,17,15,30,20);
				$pdf->SetFont('Arial','',7);
				$pdf->Ln();


				$i = 0;
				$z = 0;
				$contador = 0;

				
				foreach ($_POST['sku'] as $val){

					if (!function_exists('countCharsToFitWidth')) {
						function countCharsToFitWidth($text, $width, $pdf) {
							$textWidth = $pdf->GetStringWidth($text);
							$charCount = strlen($text);
						
							while ($textWidth > $width && $charCount > 0) {
								$text = substr($text, 0, $charCount - 1);
								$charCount--;
								$textWidth = $pdf->GetStringWidth($text);
							}
						
							return $charCount;
						}
					}
	

					if(empty($_POST['serie'][$i]) || !isset($_POST['serie'][$i]) || $_POST['serie'][$i] == '' || $_POST['serie'][$i] == ' ' || $_POST['serie'][$i] == '0'){
						$serie = '';
					}else{
						$serie = $_POST['serie'][$i];
					}
					if($_POST['devolver'][$i] > 0){

						$resultado_final = $ges->update_stock_tecnico2(intval($_POST['devolver'][$i]),$_POST['sku'][$i],$_POST['tecnico'][$i],$serie,$_POST['estado'][$i],intval($_POST['cantidad'][$i]),3,$_POST['observacion'][$i]);
						$producto = $ges->get_producto_especifico($_POST['sku'][$i]);

						if($contador == 20){
							$pdf->AddPage();
							$pdf->Ln(2);
							$pdf->Ln(11);
							$pdf->SetFont('Arial','B',8);
							$pdf->Cell(78,8,utf8_decode('DESCRIPCIÓN'),1);
							$pdf->Cell(17,8,'CANTIDAD',1);
							$pdf->Cell(15,8,'UND',1);
							$pdf->Cell(30,8,'SERIE',1);
							$pdf->Cell(20,8,'ESTADO',1);
							$pdf->Cell(30,8,utf8_decode('OBSERVACIÓN'),1);
							$w =array(78,17,15,30,20);
							$pdf->SetFont('Arial','',7);
							$pdf->Ln();
						}

						$texto1 = utf8_decode($_POST['np'][$i]);
						$ancho_celda1 = $w[0];
						$longitud_texto1 = $pdf->GetStringWidth($texto1);
						
						if ($longitud_texto1 > $ancho_celda1) {
							$charCount1 = countCharsToFitWidth($texto1, $ancho_celda1-3, $pdf);
							$texto1 = substr($texto1, 0, $charCount1) . '...';
						}
						
						$pdf->Cell($ancho_celda1, 7, $texto1, 1);


						$pdf->Cell($w[1],7,$_POST['devolver'][$i],1);
						$pdf->Cell($w[2],7,$producto['unidad_medida'],1);
						$pdf->Cell($w[3],7,$serie,1);
						$pdf->Cell($w[4],7,$_POST['estado'][$i],1);
						$pdf->Cell($w[5],7,utf8_decode($_POST['observacion'][$i]),1);
						$contador++;

						/* $texto2 = $_POST['observacion'][$i];
						$ancho_celda2 = $w[5];
						$longitud_texto2 = $pdf->GetStringWidth($texto2);
						
						if ($longitud_texto2 > $ancho_celda2) {
							$charCount2 = countCharsToFitWidth($texto2, $ancho_celda2-3, $pdf);
							$texto2 = substr($texto2, 0, $charCount2) . '...';
						}
						
						$pdf->Cell($ancho_celda2, 7, $texto2, 1); */

						$pdf->Ln();
						$z++;

					}

					$i = $i + 1;

				}

				$pdf->Ln();

				$y = array(50);
				$pdf->SetFont('Arial','',11);
				$pdf->Cell(180,8,utf8_decode('Fecha: ').$fecha,0);
				$pdf->Ln();
				$pdf->Ln();
				$pdf->Ln();

				/* $pdf->SetFont('Arial','',11);
				$pdf->Ln();
				$pdf->Ln();
				$pdf->SetFont('Arial','',10);
				$pdf->Cell(20,10,'',0,0,'C');
				$pdf->Cell(65,10,'RESPONSABLE ALMACEN','T',0,'C');
				$pdf->Cell(20,10,'',0,0,'C');
				$pdf->Cell(65,10,'TRABAJADOR','T',0,'C');
				$pdf->Cell(20,10,'',0,0,'C');
								 */
				

				$pdf->Output($pathname,'F');

				$link_constancia = 'https://biosac.net/trinity_pruebas/almacen/pdf/devolucion_'.$id_plantilla.'.pdf';
				
				


				
				if($z == 0){

					echo'<script type="text/javascript">alert("No has seleccionado ningun producto");window.location.href="devolucion_almacen_tecnico.php?tecnico='.$id.'";</script>';

				}else{

					$correo1 = $ges->get_usuario_correo();
					$correo = $ges->enviar_constancia($link_constancia, $correo1["correo"]);
					echo '<script type="text/javascript">window.open("'.$link_constancia.'");</script>';
					echo'<script type="text/javascript">alert("SE DEVOLVIÓ CORRECTAMENTE.\n\nLINK - CONSTANCIA: https://biosac.net/almacen/pdf/devolucion_'.$cod.'.pdf");window.location.href="devolucion_almacen.php";</script>';
					

				}
				
			}

			if(isset($_SESSION['id_usuario_almacen']) && !isset($_POST['DEVOLVER'])){

				require_once("./view/devolucion_almacen_tecnico.phtml");
				
			}

?>